const path = require('path');
const OSS = require('ali-oss');

let argvStr = process.argv.slice(3).join(',');
argvStr = `{"${argvStr.replace(/\,/g, '","').replace(/=/g, '":"')}"}`;
const argvJson = JSON.parse(argvStr);

if (
  !argvJson.accessKeyId ||
  !argvJson.accessKeySecret ||
  !argvJson.zipDir ||
  !argvJson.ossUrl ||
  !argvJson.ossUrl.startsWith('hy')
)
  throw new Error('缺少参数:' + argvStr);

// console.log(argvJson);

const OSS_OPTIONS = {
  accessKeyId: argvJson.accessKeyId,
  accessKeySecret: argvJson.accessKeySecret,
  region: 'oss://qmpstartup/',
  bucket: 'qmpstartup',
  endpoint: 'https://oss-cn-beijing.aliyuncs.com',
}; 

function uploadFile(sourceDir, ossDir) {
  const store = new OSS(OSS_OPTIONS);
  // https://gtable.oss-cn-beijing.aliyuncs.com/apps/hy/RELEASESjson
  return store.put(`apps/${ossDir}`, `${sourceDir}`, { timeout: 300000 }).then(
    (res) => {
      console.log('上传成功:', sourceDir, '=>', res.url);
    },
    (reason) => {
      console.log('上传失败!', reason);
    }
  );
}

const zipDir = path.join(process.cwd(), argvJson.zipDir); 
uploadFile(zipDir, argvJson.ossUrl);
